-- Wheelie.lua, by Speccy#5077.
-- Completely reusable. Please commit CTRL-S / Command-S every now, and then, or I'll have you eternally damned.

--Modify this code here to give your character Wheelie support!
local SKIN = "mkwiiluigi" -- The skin name of your character.
local SKIN_STATS = {
    hasSprite = true, -- Have wheelie sprites? Sure, you can use them!
    wheelieFrame = U, -- What frame do you have them on? We'll use that.
    hasDust = true, -- Should dust display?
    dustRadius = mobjinfo[MT_PLAYER].radius/3, -- If so, what's the radius around the player?
    wheelieSound = true
}

-- You can ignore the rest of this code if all you're doing is adding compatibility.

if wheelieMod == nil then
	rawset(_G, "wheelieMod", {
		skins = {
			[SKIN] = SKIN_STATS
		}
	})
end

wheelieMod.skins[SKIN] = SKIN_STATS

-- Create a new wheelieMod!
rawset(_G, "wheelieMod", {
    skins = {
        [SKIN] = SKIN_STATS
    }
})
local wM = wheelieMod

freeslot("S_WHEELIE", "sfx_wille") -- wille funny

states[S_WHEELIE] = {
    sprite = SPR_PLAY,
    frame = W,
    tics = -1,
    nextstate = mobjinfo[MT_PLAYER].spawnstate
}

-- Ported from SRB2.

local function P_SpawnWheelieDust(player, radius)
	local mo = player.mo
	local particle = P_SpawnMobj(mo.x, mo.y, mo.z, MT_DRIFTDUST)
	radius = $ / FRACUNIT
	P_SetOrigin(particle, particle.x + P_RandomRange(-radius, radius)*FRACUNIT,
	particle.y + P_RandomRange(-radius, radius) << FRACBITS, particle.z)
	particle.fuse = 10

	particle.destscale = (2*mo.scale)/3
	P_SetScale(particle, particle.destscale)
	P_SetObjectMomZ(particle, FRACUNIT, false)

	if (mo.eflags & (MFE_TOUCHWATER|MFE_UNDERWATER)) // overrides fire version
		particle.state = S_SMALLBUBBLE
	elseif (player.powers[pw_shield] == SH_ELEMENTAL)
		particle.state = S_SPINFIRE1
	end
		
	return particle -- I want to do this, dunno why.
end

addHook("PlayerThink", function(p)
	--print(p.cmd.angleturn) --Ignore this Speccy :)
	if not (p.mo and p.mo.valid) then return end
	if wM.skins[p.mo.skin] == nil return end
	
	-- This is pretty stupid, please fix it. :(

	if not (p.cmd.buttons & BT_CUSTOM1) then
		p.wkeypressed = 0
	else
		p.wkeypressed = $ + 1
	end
	
	if P_IsObjectOnGround(p.mo) and p.speed > 4*FRACUNIT and not (p.kartstuff[k_spinouttimer] or p.wheeliecooldown or p.wheelie or p.kartstuff[k_offroad] or p.kartstuff[k_justbumped] or p.kartstuff[k_jmp]) then
		if p.wkeypressed == 1 then
			p.wheelie = 3*TICRATE -- Wheelies last ~3 seconds.
		end
	end
	
	if p.wheelie then
		if (p.kartstuff[k_spinouttimer] or p.kartstuff[k_offroad] or p.kartstuff[k_jmp]) or (p.cmd.buttons & BT_BRAKE) then 
			p.wheeliecooldown = TICRATE/2
			p.wheelie = 0
			p.mo.state = mobjinfo[MT_PLAYER].spawnstate
			if BLib
				BLib.SetBoost(p, "wheelie", 0, 0, 0, false, false, false)
			end
			if wM.skins[p.mo.skin].customSound ~= nil then
				if S_SoundPlaying(p.mo, wM.skins[p.mo.skin].customSound) then
					S_StopSoundByID(p.mo, wM.skins[p.mo.skin].customSound)
				end
			else
				if S_SoundPlaying(p.mo, sfx_wille) then
					S_StopSoundByID(p.mo, sfx_wille)
				end
			end
			return
		elseif (p.wkeypressed == 1 and p.wheelie < 3*TICRATE) then
			p.wheelie = 0
			p.wheeliecooldown = TICRATE/2
			if BLib
				BLib.SetBoost(p, "wheelie", 0, 0, 0, false, false, false)
			end
			if wM.skins[p.mo.skin].customSound ~= nil then
				if S_SoundPlaying(p.mo, wM.skins[p.mo.skin].customSound) then
					S_StopSoundByID(p.mo, wM.skins[p.mo.skin].customSound)
				end
			else
				if S_SoundPlaying(p.mo, sfx_wille) then
					S_StopSoundByID(p.mo, sfx_wille)
				end
			end
			return
		elseif p.kartstuff[k_justbumped] then
			p.wheelie = 0
			p.wheeliecooldown = 3*TICRATE
			K_SpinPlayer(p, p.mo, 1, p.mo, false)
			if BLib
				BLib.SetBoost(p, "wheelie", 0, 0, 0, false, false, false)
			end
			if wM.skins[p.mo.skin].customSound ~= nil then
				if S_SoundPlaying(p.mo, wM.skins[p.mo.skin].customSound) then
					S_StopSoundByID(p.mo, wM.skins[p.mo.skin].customSound)
				end
			else
				if S_SoundPlaying(p.mo, sfx_wille) then
					S_StopSoundByID(p.mo, sfx_wille)
				end
			end
		end
		if wM.skins[p.mo.skin].hasSprite then
			p.mo.state = S_WHEELIE
			p.mo.frame = wM.skins[p.mo.skin].wheelieFrame
		end
		if P_IsObjectOnGround(p.mo) and wM.skins[p.mo.skin].hasDust and p.wheelie%4==0 then
			P_SpawnWheelieDust(p, wM.skins[p.mo.skin].dustRadius)
		end
		if wM.skins[p.mo.skin].wheelieSound then
			if wM.skins[p.mo.skin].customSound ~= nil then
				if not S_SoundPlaying(p.mo, wM.skins[p.mo.skin].customSound) then
					S_StartSound(p.mo, wM.skins[p.mo.skin].customSound)
				end
			else
				if not S_SoundPlaying(p.mo, sfx_wille) then
					S_StartSound(p.mo, sfx_wille)
				end
			end
		end
		local ghost = P_SpawnGhostMobj(p.mo)
		ghost.fuse = 2
		if BLib
			BLib.SetBoost(p, "wheelie", FRACUNIT/3, 0, 1*FRACUNIT/10, true, true, false)
		else
			p.kartstuff[k_speedboost] = max($, FRACUNIT/3) -- ~33% percent speed increase.
		end
		if p.wheelie == 1 then
			p.mo.state = mobjinfo[MT_PLAYER].spawnstate
			p.mo.frame = A
			p.wheeliecooldown = TICRATE/2+1
		end
		--Hi Speccy, there's the stuff in question :) <3 -Jana
		p.curangle = p.cmd.angleturn<<16
		p.deltaangle = p.curangle - p.prevangle
		if p.deltaangle > ANG1 then
			p.mo.angle = p.trueprevangle + ANG1
		elseif p.deltaangle < -ANG1 then
			p.mo.angle = p.trueprevangle - ANG1
		end
		
		--print(p.deltaangle)
		
		p.wheelie = $ - 1
	end
	
	if p.wheeliecooldown then
		p.wheeliecooldown = $ - 1
	end
	p.prevangle = p.cmd.angleturn<<16
	p.trueprevangle = p.mo.angle
end)